#line 1 "C:/Evil Genius/MikroC/P16F887/sRTC with Time Set/sRTCTimeSet.c"
#line 1 "c:/evil genius/mikroc/p16f887/srtc with time set/delay.h"




void Delay5us()
{
Delay_us(5);
}

void Delay20us()
{
Delay_us(20);
}

void Delay5ms()
{
Delay_ms(5);
}

void Delay10ms()
{
Delay_ms(10);
}

void Delay100ms()
{
Delay_ms(100);
}

void Delay150ms()
{
Delay_ms(150);
}

void Delay500ms()
{
Delay_ms(500);
}

void Delay1000ms()
{
Delay_ms(1000);
}
#line 1 "c:/evil genius/mikroc/p16f887/srtc with time set/slcd.h"
#line 17 "c:/evil genius/mikroc/p16f887/srtc with time set/slcd.h"
const sLCD_FIRST_ROW = 128;
const sLCD_SECOND_ROW = 192;
const sLCD_THIRD_ROW = 148;
const sLCD_FOURTH_ROW = 212;
const sLCD_CLEAR = 1;
const sLCD_RETURN_HOME = 2;
const sLCD_CURSOR_OFF = 12;
const sLCD_UNDERLINE_ON = 14;
const sLCD_BLINK_CURSOR_ON = 15;
const sLCD_MOVE_CURSOR_LEFT = 16;
const sLCD_MOVE_CURSOR_RIGHT = 20;
const sLCD_TURN_OFF = 0;
const sLCD_TURN_ON = 8;
const sLCD_SHIFT_LEFT = 24;
const sLCD_SHIFT_RIGHT = 28;


void Nybble(unsigned char LCDOut, unsigned char RS)

{
unsigned char i;
  PORTA.F5  = 0;
 for (i = 0; i < 6; i++)
 {
  PORTA.F4  = 1;
 Delay5us();
  PORTA.F4  = 0;
 }
 LCDOut = LCDOut | (1 << 5) | ((RS & 1) * (1 << 4));
 for (i = 0; i < 6; i++)
 {
 if (0 != (LCDOut & (1 << 5)))
  PORTA.F5  = 1;
 else
  PORTA.F5  = 0;
 LCDOut = LCDOut << 1;
  PORTA.F4  = 1;
 Delay5us();
  PORTA.F4  = 0;
 }
  PORTA.F5  = 1;
  PORTA.F5  = 1;
  PORTA.F5  = 0;
  PORTA.F5  = 0;

}


void sLCDWrite(unsigned char LCDData, unsigned char RSValue)

{
 Nybble((LCDData >> 4) & 0x0F, RSValue);
 Nybble(LCDData & 0x0F, RSValue);
 if ((0 == (LCDData & 0xFC)) && (0 == RSValue))
 Delay20us();
 else
 Delay20us();
}


void sLCD_Chr(unsigned char row, unsigned char col, unsigned char character)

{
 sLCDWrite((row + (col - 1)), 0);
 sLCDWrite(character, 1);
}


void sLCD_Chr_Cp(unsigned char character)

{
 sLCDWrite(character, 1);
}


void sLCD_Cmd(unsigned char instruction)

{
 sLCDWrite (instruction, 0);
}


void sMove_Cursor(unsigned char row, unsigned char col)

{
 sLCDWrite((row + (col - 1)), 0);
}


int NumtoChar(unsigned char val)
{
 unsigned char ch;
 if (val < 10)
 {
 ch=val+'0';
 }
 else
 {
 val=val-10;
 ch=val + 'A';
 }
 return(ch);
}


void sResetLCD()

{
 sLCDWrite(0b00000001, 0);
 Delay5ms();
 sLCDWrite(0b00000110, 0);
 Delay5ms();
 sLCDWrite(0b00001100, 0);
 Delay5ms();
}


void sLCD_Out(unsigned char row, unsigned char col, const char s[])



{
 int i;
 sLCDWrite(row + (col - 1), 0);
 for (i = 0; s[i] != 0; i++)
 {
 sLCDWrite(s[i], 1);
 }
}


void sLCD_Out_Cp(const char s[])



{
 int i;

 for (i = 0; s[i] != 0; i++)
 {
 sLCDWrite(s[i], 1);
 }
}


void sLCDtoBCD(unsigned char row, unsigned char col, long int val, unsigned char digits)

{
 int d;
 unsigned char ch;
 sLCDWrite(row + (col - 1), 0);
 if (digits == 5)
 {
 d = val/10000;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
 }
 if (digits > 3)
 {
 val = val%10000;
 d = val/1000;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
 }
 if (digits > 2)
 {
 val = val%1000;
 d = val/100;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
 }
 if (digits > 1)
 {
 val = val%100;
 d = val/10;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
 }
 if (digits == 1)
 {
 val = val%100;
 }
 d = val % 10;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
}
#line 1 "c:/evil genius/mikroc/p16f887/srtc with time set/init_picmicro.h"

void Init_PICMicro()
{
char i;



 ANSEL = 0b00000000;
 ANSELH = 0b00000000;
 ADCON1 = 0b00000100;
 TRISA = 0b00001111;
 TRISB = 0b01111111;
 TRISC = 0b10111111;
 TRISD = 0b00000000;
 TRISE = 0b00000111;
 Soft_I2C_Config(&PORTD, 0, 1);
 PORTB = 0;



 for (i = 0; i < 3; i++)
 {
 Delay10ms();
 Nybble(3, 0);
 }
 Nybble(2, 0);
 Delay10ms();
}
#line 1 "c:/evil genius/mikroc/p16f887/srtc with time set/srtc_time_2b.h"
#line 12 "c:/evil genius/mikroc/p16f887/srtc with time set/srtc_time_2b.h"
unsigned char const monthname[] = {
 ' ', ' ', ' ',
 'J', 'A', 'N',
 'F', 'E', 'B',
 'M', 'A', 'R',
 'A', 'P', 'R',
 'M', 'A', 'Y',
 'J', 'U', 'N',
 'J', 'U', 'L',
 'A', 'U', 'G',
 'S', 'E', 'P',
 'O', 'C', 'T',
 'N', 'O', 'V',
 'D', 'E', 'C' };
unsigned char const dayname[] = {
 ' ', ' ', ' ',
 'M', 'O', 'N',
 'T', 'U', 'E',
 'W', 'E', 'D',
 'T', 'H', 'U',
 'F', 'R', 'I',
 'S', 'A', 'T',
 'S', 'U', 'N' };

struct TTime {
 int seconds, minutes, hours, day, date, month, year, control, twentyfour;
} TimeRead;
char SecondsLast;


void Delay200ms()
{
Delay_ms(200);
}

void Get_Time()
{

Soft_I2C_Start();
Soft_I2C_Write(0b11010000);
Soft_I2C_Write(0);
Delay_us(50);
Soft_I2C_Start();
Soft_I2C_Write(0b11010001);
TimeRead.seconds = Soft_I2C_Read(1);
TimeRead.minutes = Soft_I2C_Read(1);
TimeRead.hours = Soft_I2C_Read(1);
TimeRead.day = Soft_I2C_Read(1);
TimeRead.date = Soft_I2C_Read(1);
TimeRead.month = Soft_I2C_Read(1);
TimeRead.year = Soft_I2C_Read(1);
TimeRead.control = Soft_I2C_Read(0);
Soft_I2C_Stop();
TimeRead.twentyfour = TimeRead.hours;
 if (TimeRead.hours == Dec2BCD(0))
 {
 TimeRead.hours = Dec2BCD(12);
 }
 if (TimeRead.twentyfour >= Dec2BCD(13))
 {
 TimeRead.hours = (BCD2Dec(TimeRead.twentyfour) - 12);
 }
 if (TimeRead.twentyfour >= Dec2BCD(22))
 {
 TimeRead.hours = (BCD2Dec(TimeRead.twentyfour) - 6);
 }
 if (TimeRead.hours > Dec2BCD(23))
 {
 TimeRead.hours = 1;
 }
}

void Display_Time_Short(unsigned char row, unsigned char col)
{
char i, txt1[12];

 if (TimeRead.seconds != SecondsLast)
 {
 txt1[2] = ':';
 }
 else
 txt1[2] = ' ';

 txt1[0] = (TimeRead.hours >> 4) + 48;
 txt1[1] = (TimeRead.hours & 0x0F) + 48;

 txt1[3] = (TimeRead.minutes >> 4) + 48;
 txt1[4] = (TimeRead.minutes & 0x0F) + 48;
 txt1[5] = ' ';
 if (TimeRead.twentyfour > Dec2BCD(11))
 txt1[6] = 'P';
 else
 txt1[6] = 'A';
 txt1[7] = 'M';
 txt1[8] = 0;
 sLCD_Chr(row, col, txt1[0]);
 for (i = 1; i < 8; i++)
 {
 sLCD_Chr_Cp(txt1[i]);
 }
SecondsLast = TimeRead.seconds;
}

void Display_Day(unsigned char row, unsigned char col)
{
char i, txt[11];
 for (i = 0; i < 3; i++)
 {
 txt[i] = dayname[((BCD2Dec(Timeread.day) * 3) + i)];
 }

 sLCD_Chr(row, col, txt[0]);
 for (i = 1; i < 3; i++)
 {
 sLCD_Chr_Cp(txt[i]);
 }
}

void Display_Date(unsigned char row, unsigned char col)
{
char i, txt[11];
 for (i = 0; i < 3; i++)
 {
 txt[i] = monthname[((BCD2Dec(Timeread.month) * 3) + i)];
 }


 txt[3] = '/';
 txt[4] = (TimeRead.date >> 4) + 48;
 txt[5] = (TimeRead.date & 0x0F) + 48;
 txt[6] = '/';
 txt[7] = (TimeRead.year >> 4) + 48;
 txt[8] = (TimeRead.year & 0x0F) + 48;
 txt[9] = 0;
 sLCD_Chr(row, col, txt[0]);
 for (i = 1; i < 9; i++)
 {
 sLCD_Chr_Cp(txt[i]);
 }
}

void Set_Time()
{
char i, j, n, TempVal[7], txt[4], dateloop;
 j = -1;
 n = 0;
 dateloop = 0;
 Get_Time();
 TempVal[0] = BCD2Dec(TimeRead.twentyfour);
 TempVal[1] = BCD2Dec(TimeRead.minutes);
 TempVal[2] = BCD2Dec(TimeRead.seconds);
 TempVal[3] = BCD2Dec(TimeRead.month);
 TempVal[4] = BCD2Dec(TimeRead.date);
 TempVal[5] = BCD2Dec(TimeRead.year);
 TempVal[6] = BCD2Dec(TimeRead.day);
 sLCD_Out(sLCD_SECOND_ROW, 1, "                ");
 sLCD_Out(sLCD_FIRST_ROW, 1, "Set Time     ");
 sLCD_Cmd(sLCD_UNDERLINE_ON);

while (1 == 1)
 {

 if (dateloop == 2)
 {
 for (i = 0; i < 3; i++)
 {
 txt[i] = dayname[((TempVal[6] * 3) + i)];
 }

 sLCD_Chr(sLCD_SECOND_ROW, 8, txt[0]);
 for (i = 1; i < 3; i++)
 {
 sLCD_Chr_Cp(txt[i]);
 }
 }

 if (dateloop == 1)
 {
 for (i = 0; i < 3; i++)
 {
 txt[i] = monthname[((TempVal[3] * 3) + i)];
 }

 sLCD_Chr(sLCD_SECOND_ROW, 8, txt[0]);
 for (i = 1; i < 3; i++)
 {
 sLCD_Chr_Cp(txt[i]);
 }
 }

 if (dateloop == 0)
 {
 txt[0] = (Dec2BCD(TempVal[j]) >> 4) + 48;
 txt[1] = (Dec2BCD(TempVal[j]) & 0x0F) + 48;
 txt[2] = ' ';
 sLCD_Chr(sLCD_SECOND_ROW, 8, txt[0]);
 for (i = 1; i < 3; i++)
 {
 sLCD_Chr_Cp(txt[i]);
 }
 }

 if ( PORTE.F1  == 0)
 {
 while ( PORTE.F1  == 0)
 {
 }
 ++n;
 }

 if ( PORTE.F0  == 0)
 {
 while ( PORTE.F0  == 0)
 {
 }
 ++TempVal[j];
 }

switch(n)
{

case 0:

 dateloop = 0;
 j = 0;
 sLCD_Out(sLCD_SECOND_ROW, 1, "Hours: ");
 if (TempVal[j] >= 24)
 TempVal[j] = 0;

break;

case 1:

 j = 1;
 sLCD_Out(sLCD_SECOND_ROW, 1, "Mins : ");
 if (TempVal[j] >= 60)
 TempVal[j] = 0;


break;

case 2:

 j = 2;
 sLCD_Out(sLCD_SECOND_ROW, 1, "Secs : ");
 if (TempVal[j] >= 60)
 TempVal[j] = 0;


break;

case 3:

 dateloop = 1;
 j = 3;
 sLCD_Out(sLCD_SECOND_ROW, 1, "Month: ");
 if (TempVal[j] >= 13)
 TempVal[j] = 1;


break;

case 4:

 dateloop = 0;
 j = 4;
 sLCD_Out(sLCD_SECOND_ROW, 1, "Date : ");
 if (TempVal[j] >= 32)
 TempVal[j] = 0;


break;

case 5:

 j = 5;
 sLCD_Out(sLCD_SECOND_ROW, 1, "Year : ");
 if (TempVal[j] >= 16)
 TempVal[j] = 8;


break;

case 6:

 dateloop = 2;
 j = 6;
 sLCD_Out(sLCD_SECOND_ROW, 1, "Day : ");
 if (TempVal[j] >= 8)
 TempVal[j] = 1;


break;

case 7:

 sResetLCD();
 TimeRead.seconds = Dec2BCD(TempVal[2]);
 TimeRead.minutes = Dec2BCD(TempVal[1]);
 TimeRead.hours = Dec2BCD(TempVal[0]);
 TimeRead.day = Dec2BCD(TempVal[6]);
 TimeRead.date = Dec2BCD(TempVal[4]);
 TimeRead.month = Dec2BCD(TempVal[3]);
 TimeRead.year = Dec2BCD(TempVal[5]);
 TimeRead.control = 0;
 Soft_I2C_Start();
 Soft_I2C_Write(0b11010000);
 Soft_I2C_Write(0);
 Soft_I2C_Write(TimeRead.seconds);
 Soft_I2C_Write(TimeRead.minutes);
 Soft_I2C_Write(TimeRead.hours);
 Soft_I2C_Write(TimeRead.day);
 Soft_I2C_Write(TimeRead.date);
 Soft_I2C_Write(TimeRead.month);
 Soft_I2C_Write(TimeRead.year);
 Soft_I2C_Write(TimeRead.control);
 Soft_I2C_Stop();
 return;

break;

Delay200ms();
 }
 }
}

Alarm(char hh, char mm, char ss, char mo, char dd, char yr)
{
char trip;
Get_Time();
if (TimeRead.twentyfour == Dec2BCD(hh) && TimeRead.minutes == Dec2BCD(mm)
 && TimeRead.seconds == Dec2BCD(ss) && TimeRead.month == Dec2BCD(mo)
 && TimeRead.date == Dec2BCD(dd) && TimeRead.year == Dec2BCD(yr))
 {
 trip = 1;
 return trip;
 }
 trip = 0;
 return trip;
}
#line 24 "C:/Evil Genius/MikroC/P16F887/sRTC with Time Set/sRTCTimeSet.c"
const char Message1[17] = "sRTC Time Demo  ";
const char Message2[17] = "P16F887         ";
const char Message7[17] = "Set Alarm Time  ";
const char Message19[17] = "Message Display ";
const char Message20[17] = "                ";

void main()
{
unsigned char i, mode, Tripped;
Init_PICMicro();
 sResetLCD();
 Delay500ms();
 sLCD_Out(sLCD_FIRST_ROW, 1, Message1);
 sLCD_Out(sLCD_SECOND_ROW, 1, Message2);
 Delay1000ms();
 Delay1000ms();
 sLCD_Out(sLCD_FIRST_ROW, 1, Message20);
 sLCD_Out(sLCD_SECOND_ROW, 1, Message20);
 Delay1000ms();



while (1 == 1)
 {
 if ( PORTE.F1  == 0)
 {
 while ( PORTE.F1  == 0)
 {
 }
 Set_Time();
 }

 Get_Time();
 Display_Time_Short(sLCD_FIRST_ROW, 1);
 Display_Date(sLCD_SECOND_ROW, 1);
 Display_Day(sLCD_FIRST_ROW, 10);
 Tripped = Alarm(18, 33, 5, 3, 29, 9);
 if (Tripped == 1)
 PORTB = 0b10000000;

 Delay500ms();

 }
}
